﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'********************************************************************************
'*  STORE EDITOR CLASS MODULE                                                   *
'********************************************************************************

Sub Class_Globals

	Private fx					As JFX
	Private fmrStoreEditor		As Form
	'Define Form Properties
	Private m_sFormFlagRecordEdit	As String		'RecordEdit = View/Add/Edit/Delete
	Private m_sRecordAction			As String
	'Define Record Field(s)
	Private TextBox_RecordIndex		As TextField
	Private TextBox_RecordNumber	As TextField
	Private TextBox_DateAdded		As TextField
	Private TextBox_DateModified	As TextField
	Private TextBox_StoreName		As TextField
	Private TextBox_AddressLine1	As TextField
	Private TextBox_AddressLine2	As TextField
	Private TextBox_City			As TextField
	Private TextBox_State			As TextField
	Private TextBox_ZipCode			As TextField
	Private TextBox_PhoneNumber		As TextField
	Private TextBox_FAXNumber		As TextField
	Private TextBox_WebSite			As TextField
	'Define Form Buttons
	Private Button_Add			As Button
	Private Button_Edit			As Button
	Private Button_Delete		As Button
	Private Button_Save 		As Button
	Private Button_Confirm 		As Button
	Private Button_Cancel 		As Button
	Private Button_Close		As Button

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)

	fmrStoreEditor.Initialize("fmrStoreEditor",0,0)
	fmrStoreEditor.Title = "STORE EDITOR"
	fmrStoreEditor.SetFormStyle("UTILITY")
	fmrStoreEditor.Resizable = False
	fmrStoreEditor.RootPane.LoadLayout("frmStoreEditor.fxml") 'Load the layout file.
	fmrStoreEditor.SetOwner(Parent)
	m_sFormFlagRecordEdit = "View"
	subFormProcess

End Sub

Public Sub subFormProcess

	subFormStateButtons
	
End Sub

Public Sub Show

	fmrStoreEditor.ShowAndWait	' Modal dialog
	
End Sub

'********************************************************************************
'*  ADD NEW RECORD TO TABLE                                                     *
'********************************************************************************

Sub Button_Add_Action

	m_sFormFlagRecordEdit = "Add"
	subFormStateButtons

End Sub

'********************************************************************************
'*  EDIT EXISTING RECORD IN TABLE                                               *
'********************************************************************************

Sub Button_Edit_Action

	m_sFormFlagRecordEdit = "Edit"
	subFormStateButtons

End Sub

'********************************************************************************
'*  DELETE SELECTED RECORD FROM TABLE                                           *
'********************************************************************************

Sub Button_Delete_Action

	m_sFormFlagRecordEdit = "Delete"
	subFormStateButtons

End Sub

'********************************************************************************
'*  SAVE RECORD TO TABLE                                                        *
'********************************************************************************

Sub Button_Save_Action

	subSaveRecordProperties
	m_sFormFlagRecordEdit = "View"
	subFormStateButtons

End Sub 

'********************************************************************************
'*  CANCEL CHANGES TO SELECTED RECORD                                           *
'********************************************************************************

Sub Button_Cancel_Action

	m_sFormFlagRecordEdit = "View"
	subFormStateButtons

End Sub 

'********************************************************************************
'*  CONFIRM RECORD CHANGES                                                      *
'********************************************************************************

Sub Button_Confirm_Action

	m_sFormFlagRecordEdit = "View"
	subFormStateButtons

End Sub

'********************************************************************************
'*  CLOSE FORM                                                                  *
'********************************************************************************

Sub Button_Close_Action

	fmrStoreEditor.Close
	
End Sub

'********************************************************************************
'*  FORM BUTTON STATE                                                           *
'********************************************************************************

Sub subFormStateButtons

	Select Case m_sFormFlagRecordEdit
		Case "View"
		Button_Add.Visible = True
		Button_Edit.Visible = True
		Button_Delete.Visible = True
		Button_Save.Visible = False
		Button_Cancel.Visible = False
		Button_Confirm.Visible = False
		Case "Add", "Edit"
		Button_Add.Visible = False
		Button_Edit.Visible = False
		Button_Delete.Visible = False
		Button_Save.Visible = True
		Button_Cancel.Visible = True
		Button_Confirm.Visible = False
		Case "Delete"
		Button_Add.Visible = False
		Button_Edit.Visible = False
		Button_Delete.Visible = False
		Button_Save.Visible = False
		Button_Cancel.Visible = True
		Button_Confirm.Visible = True
	End Select
	
End Sub

' inserts Textfield entries into an Account Table
' Validate Entries should be done first!!
' DM.SQL1 address the SQL1 object in the DM Module

Sub subSaveRecordProperties

	Dim mRecordMap As Map
	mRecordMap.Initialize
	mRecordMap.Put("Store_ID",Null)
	mRecordMap.Put("Store_DateAdded",TextBox_DateAdded.Text)
	mRecordMap.Put("Store_DateModified",TextBox_DateModified.Text)
	mRecordMap.Put("Store_CodeSequence",TextBox_RecordNumber.Text)
	mRecordMap.Put("Store_Nam",TextBox_StoreName.Text)
	mRecordMap.Put("Store_AddressLine1",TextBox_AddressLine1.Text)
	mRecordMap.Put("Store_AddressLine2",TextBox_AddressLine2.Text)
	mRecordMap.Put("Store_City",TextBox_AddressLine1.Text)
	mRecordMap.Put("Store_State",TextBox_AddressLine2.Text)
	mRecordMap.Put("Store_ZipCode",TextBox_ZipCode.Text)
	mRecordMap.Put("Store_PhoneNumber",TextBox_PhoneNumber.Text)
	mRecordMap.Put("Store_FAXNumber",TextBox_FAXNumber.Text)
	mRecordMap.Put("Store_WebSite",TextBox_WebSite.Text)
	DBUtils.InsertMaps(dmStore.SQL1, "tblStore", Array As Object(mRecordMap))

End Sub

